Attribute VB_Name = "ModBnet"
Public Function MakeServer(data As String) As String
    MakeServer = CLng("&H" & ToHex(Mid(data, 1, 1))) & "." & CLng("&H" & ToHex(Mid(data, 2, 1))) & "." & CLng("&H" & ToHex(Mid(data, 3, 1))) & "." & CLng("&H" & ToHex(Mid(data, 4, 1)))
End Function

Public Sub Send0x51()
    With PBuffer
        .InsertDWORD GTC
        .InsertDWORD Version
        .InsertDWORD CheckSum
        If varProduct = "PX2D" Then
            .InsertDWORD &H2
        Else
            .InsertDWORD &H1
        End If
        .InsertDWORD &H0
        .InsertNonNTString CdkeyHash
        If varProduct = "PX2D" Then
            .InsertNonNTString Cdkey2Hash
        End If
        .InsertNTString ExeInfo
        .InsertNTString varUsername
        .SendPacket &H51
    End With
End Sub

Public Sub Send0x50()
    With PBuffer
        .InsertDWORD &H0
        .InsertNonNTString "68XI" & varProduct
        .InsertDWORD varVerbyte
        .InsertDWORD &H0
        .InsertDWORD &H0
        .InsertDWORD &H480
        .InsertDWORD &H1033
        .InsertDWORD &H1033
        .InsertNTString "USA"
        .InsertNTString "United States"
        .SendPacket &H50
    End With
End Sub

Public Sub RequestBnetNews()
    With PBuffer
        .InsertDWORD &H0
        .SendPacket &H46
    End With
End Sub


Public Function GetChannelType(ByVal Flags As Long) As String
    Select Case Flags
        Case CHNFLAG_VOID
            GetChannelType = "Chatless Channel"
        Case CHNFLAG_MOD
            GetChannelType = "Moderated channel"
        Case CHNFLAG_STS
            GetChannelType = "Product-Specific Channel"
        Case CHNFLAG_PUB
            GetChannelType = "Public Channel"
        Case Else
            GetChannelType = "Private Channel"
    End Select
End Function


Public Sub ParseBnet(data As String)
Dim PacketId As Byte, RP As Long, outb As String
Dim accountHash As String
    
    PacketId = Asc(Mid(data, 2, 1))
    
    Select Case PacketId
        Case &H0
            With PBuffer
                .SendPacket &H0
            End With
        Case &H34
            HType = 1
            With PBuffer
                .InsertDWORD &H8
                .InsertDWORD &H0
                .InsertNonNTString "password"
                .SendBNLSPacket &HB
            End With
        Case &H3E
            Dim server As String, Bleh2 As String
                P1 = Mid(data, 5, 16)
                server = Mid(data, 17, 8)
                Bleh2 = Mid(server, 5, 4)
                rtbAdd "Current realm server: " & MakeServer(Bleh2) & vbNewLine, vbGreen
                P2 = Mid(data, 29, 48)
                frmMain.wsRealm.Close
                frmMain.wsRealm.Connect MakeServer(Bleh2), 6112
        Case &H51
            Select Case GetWORD(Mid(data, 5, 2))
                Case &H0
                    rtbAdd "BNET: Version and CDKeys Passed." & vbNewLine, vbYellow
                    With PBuffer
                        If varProduct = "3RAW" Then
                            .InsertNTString varUsername
                            .InsertNTString varPassword
                            .SendBNLSPacket &H2
                        Else
                            .InsertNonNTString "bnet"
                            .SendPacket &H14
                            .SendPacket &H2D
                            If Cpass = False Then
                                HType = 1
                                .InsertDWORD Len(varPassword)
                                .InsertDWORD &H0
                                .InsertNonNTString varPassword
                                .SendBNLSPacket &HB
                                SPass = True
                            Else
                                Cpass = False
                                HType = 3
                                .InsertDWORD Len(varPassword)
                                .InsertDWORD &H0
                                .InsertNonNTString varPassword
                                .SendBNLSPacket &HB
                            End If
                        End If
                    End With
                Case &H101
                    rtbAdd "Incorrect game version." & vbNewLine, vbRed
                Case &H200
                    rtbAdd "Incorrect cdkey(s)." & vbNewLine, vbRed
                Case &H100
                    rtbAdd "Incorrect game version." & vbNewLine, vbRed
                Case &H203
                    rtbAdd "Incorrect cdkey for this product." & vbNewLine, vbRed
                Case &H202
                    rtbAdd "Current cdkey is banned from Battle.net." & vbNewLine, vbRed
                Case &H201
                    rtbAdd "Current cdkey is in use by " & Mid(data, 9, Len(data) - 9) & vbNewLine, vbRed
            End Select
        Case &H25
            PBuffer.InsertNonNTString Mid(data, 5, 4)
            PBuffer.SendPacket &H25
            Exit Sub
        Case &H53
            If Asc(Mid$(data, 5, 1)) = &H1 Then
                If AttemptedC = False Then
                With PBuffer
                    .InsertNTString varPassword
                    .InsertNTString varPassword
                    .SendBNLSPacket &H4
                End With
                AttemptedC = True
                End If
            Else
                With PBuffer
                    .InsertNonNTString Mid(data, 9, 64)
                    .SendBNLSPacket &H3
                End With
            End If
        Case &H52
            Select Case GetWORD(Mid(data, 5, 2))
                Case &H0
                    With PBuffer
                        .InsertNTString varUsername
                        .InsertNTString varPassword
                        .SendBNLSPacket &H2
                    End With
                Case Else
            End Select
        Case &H54
            Select Case GetWORD(Mid(data, 5, 2))
            Case &H0
                rtbAdd "BNET: Logon Passed!" & vbNewLine, vbGreen
                With PBuffer
                    .InsertNTString varUsername
                    .InsertBYTE 0
                    .SendPacket &HA
                    .InsertNonNTString varProduct
                    .SendPacket &HB
                    .InsertDWORD 1
                    .InsertNTString "L"
                    .SendPacket &HC
                End With
            Case &H2
                rtbAdd "BNET: Logon Failed!" & vbNewLine, vbRed
                If AttemptedC = False Then
                With PBuffer
                    .InsertNTString varUsername
                    .InsertNTString varPassword
                    .SendBNLSPacket &H4
                End With
                AttemptedC = True
                End If
            End Select
            
        Case &H50
            Dim mpqn As Long, hash As String, MPQName As String
                Servers = Val("&h" & StrToHex(StrReverse(Mid(data, 9, 4))))
                MPQName = Mid(data, 25, 12)
                hash = Mid(data, 38, Len(data) - 2)
                mpqn = Val(Mid(MPQName, 8, 1))
                      With PBuffer
                         .InsertDWORD GetBNLSByte()
                         .InsertDWORD CLng(mpqn)
                         .InsertNTString hash
                         .SendBNLSPacket &H9
                      End With
                      
        Case &H46 ' get news reply
            Dim tmpnews As Long
            Dim spltns() As String
                spltns() = Split(StrToHex(Mid(data, 22)), "0A")
                For tmpnews = 0 To UBound(spltns) - 1
                    rtbAdd "News: " & HexToStr(spltns(tmpnews)) & vbNewLine, vbYellow
                Next tmpnews
                Exit Sub
            Erase spltns()
            
        Case &H31 ' password change reply
            If InStr(data, Chr(&H1)) Then
                rtbAdd "Password changed, logging on." & vbNewLine, vbGreen
            Else
                rtbAdd "Password not changed." & vbNewLine, vbRed
            End If
            
        Case &H3A ' account login reply
            Select Case Asc(Mid(data, 5, 1))
                Case &H1
                    rtbAdd "BNET: Logon failed!" & vbNewLine, vbRed
                    If AttemptedC = False Then
                        With PBuffer
                            HType = 2
                            .InsertDWORD Len(varPassword)
                            .InsertDWORD &H0
                            .InsertNonNTString varPassword
                            .SendBNLSPacket &HB
                        End With
                        AttemptedC = True
                    End If
                Case &H2
                    rtbAdd "BNET: Logon failed, due to incorrect password." & vbNewLine, vbRed
                Case &H0
                    rtbAdd "BNET: Logon Passed!" & vbNewLine, vbYellow
                    With PBuffer
                        If LRealm = True And varProduct = "VD2D" Or varProduct = "PX2D" Then
                            .InsertDWORD &H0
                            .InsertDWORD &H0
                            .InsertBYTE &H0
                            .SendPacket &H34
                        Else
                            .InsertNTString varUsername
                            .InsertBYTE 0
                            .SendPacket &HA
                            .InsertNonNTString varProduct
                            .SendPacket &HB
                            .InsertDWORD 1
                            .InsertNTString "L"
                            .SendPacket &HC
                        End If
                    End With
                Case Else
            End Select
            Exit Sub
            
        Case &HF
            frmMain.ChatBot.DispatchMessage data
            Exit Sub
        Case &H2A
        Case &HA
            Dim spltn() As String, strss As String
                spltn() = Split(data, Chr(0), 5)
                modStatstring.ParseStatString spltn(2), strss
                
                rtbAdd "Logged on as " & spltn(1) & " (" & spltn(3) & ", " & strss & "" & vbNewLine, vbCyan
                frmMain.wsbnls.Close
                BNET.TrueUsername = spltn(3)
            Erase spltn()
                With PBuffer
                    .InsertNTString "/join " & varHome
                    .SendPacket &HE
                End With
            Exit Sub
        Case &HB
            Dim Split0B() As String
            Dim Z As Integer
                Split0B() = Split(Mid(data, 5, Len(data)), Chr(0))
                For Z = 0 To UBound(Split0B) - 2
                    'frmConfigBNET.lstChannels.ListItems.Add , , Split0B(Z)
                Next Z
            Erase Split0B()
            Exit Sub
        Case &H19
            rtbAdd "[&H19]: " & Replace(Mid(data, 9, Len(data)), Chr(0), "") & vbNewLine, vbGreen
            Exit Sub
        Case &H15
            Dim asplt() As String
                asplt() = Split(Mid(data, 21), Chr(0), 3)
                rtbAdd "Ad banner is now " & asplt(0) & " [url=" & asplt(1) & "]" & vbNewLine, vbGreen
            Erase asplt()
        Case &H2D
            Dim splti() As String
                splti() = Split(Mid(data, 1, Len(data) - 1), Chr(1), 2)
                rtbAdd "Using " & splti(1) & " as icons file." & vbNewLine, vbGreen
            Erase splti()
        Case Else
            If Len(PacketId) = 1 Then
                rtbAdd "Unhandled Packet: 0x0" & Hex(PacketId) & vbNewLine, vbRed
            Else
                rtbAdd "Unhandled Packet: 0x" & Hex(PacketId) & vbNewLine, vbRed
            End If
            rtbAdd StrToHex(data) & vbNewLine, vbRed
    End Select
End Sub

